/*

.   test_plf_filters.cpp 

template<class Img>
int plf_test_Median(int r,Img* input,std::string out_name)
{
	Plf::SrcAImage<unsigned,Img> src("src",input);
	Plf::DstAImage<unsigned,Img> dst("dst");

	Plf::medianFilter<unsigned> medianf(r,input->Bits(),"medain");
	src.out.ConnectTo(&medianf.in);
	medianf.out.ConnectTo(&dst.in);

	Plf::FiltersSystem sys(out_name+".dot");
//------ Assing task------------------------
	sys.Assign(&src,&dst);
//------ Initialize destinations -----------
	Plf::ImgSize is=dst.in.getImageSize();
	std::auto_ptr<AImage> _out(::AImageCreate(0,AImage::YImageClass::IMGC_GRAYSCALE,is.width,is.height,input->Bits()));
	Img *out=dynamic_cast<Img *>(_out.get());
	if(out==0)
		return 1;
	dst.setDstImage(out);

	sys.Run(indicator,out_name.c_str());

	std::string fn=out_name+".tif";
	::AImageSave(out,fn.c_str(),indicator);
	return 0;
}

template<class Img>
int plf_test_Median2(int r,Img* input,std::string out_name)
{
	Plf::SrcAImage<unsigned,Img> src("src",input);
	Plf::DstAImage<unsigned,Img> dst("dst");

	Plf::medianFilter2<unsigned> medianf(r,input->Bits(),"medain2");
	src.out.ConnectTo(&medianf.in);
	medianf.out.ConnectTo(&dst.in);

	Plf::FiltersSystem sys(out_name+".dot");
//------ Assing task------------------------
	sys.Assign(&src,&dst);
//------ Initialize destinations -----------
	Plf::ImgSize is=dst.in.getImageSize();
	std::auto_ptr<AImage> _out(::AImageCreate(0,AImage::YImageClass::IMGC_GRAYSCALE,is.width,is.height,input->Bits()));
	Img *out=dynamic_cast<Img *>(_out.get());
	if(out==0)
		return 1;
	dst.setDstImage(out);

	sys.Run(indicator,out_name.c_str());

	std::string fn=out_name+".tif";
	::AImageSave(out,fn.c_str(),indicator);
	return 0;
}
*/