#ifndef _VTL_META_SIZELIST_H
#define _VTL_META_SIZELIST_H
///////////////////////////////////////////////////////////////////////////////////////////
#include <iostream>
#include "vtl_meta_tools.h" 
#include "vtl_meta_IndexList.h" 
///////////////////////////////////////////////////////////////////////////////////////////
namespace Vtl
{
namespace Meta
{
	namespace Impl
	{
		template<class IList,int sz>
		struct SizeList_base_0
		{
			enum { hasInts=sz};
			int non_enums[sz];
		};
		template<class IList>
		struct SizeList_base_0<IList,0>
		{
			enum { hasInts=0};
		};
	}//namespace Impl
	///
	///
	///
	template<class T_IList>
	struct SizeList_base
		: protected Impl::SizeList_base_0<T_IList,IL::Count<0,T_IList>::value>
	{
		SizeList_base_0::hasInts; //!< make base class member public
		typedef T_IList IList;
		enum { size=IL::Length<IList>::value};
	protected:
		//~SizeList_base() {}
		//SizeList_base() {}
		//SizeList_base(const SizeList_base&) {}
	public:
		template<int i>
		bool isEnum() const
		{
			return (IL::Elem<i,IList>::value != 0);
		}
		template<int i>
		int x() const
		{
			return get_x<i>( Loki::Bool2Type< IL::Elem<i,IList>::value != 0 >() );
		}
	//protected:
		///    ,  enum,   int -         .
		template<int i>
		void set(int value)
		{
			return set_x<i>(value, Loki::Bool2Type< IL::Elem<i,IList>::value != 0 >() );
		}
		void set_all(int i_0,int i_1=-1,int i_2=-1,int i_3=-1,int i_4=-1,int i_5=-1,int i_6=-1,int i_7=-1,int i_8=-1,int i_9=-1,int i_10=-1,int i_11=-1,int i_12=-1,int i_13=-1,int i_14=-1,int i_15=-1,int i_16=-1,int i_17=-1,int i_18=-1,int i_19=-1)
		{
			enum {n=IL::Length<IList>::value};
			set_all_<0,n>(Loki::Bool2Type<(0<n)>(),i_0,i_1,i_2,i_3,i_4,i_5,i_6,i_7,i_8,i_9,i_10,i_11,i_12,i_13,i_14,i_15,i_16,i_17,i_18,i_19);
		}
	private:
		/// data is enum
		template<int i>
		int get_x(Loki::Bool2Type<true> ) const
		{
			return IL::Elem<i,IList>::value;
		}
		/// data is int variable
		template<int i>
		int get_x(Loki::Bool2Type<false> ) const
		{
			return non_enums[IL::ICount<0,i,IList>::value];
		}
		/// data is enum
		template<int i>
		void set_x(int value,Loki::Bool2Type<true> ) const
		{
		}
		/// data is int variable
		template<int i>
		void set_x(int value,Loki::Bool2Type<false> )
		{
			non_enums[IL::ICount<0,i,IList>::value]=value;
		}
		template<int i,int n>
		void set_all_(Loki::Bool2Type<true> ,int i_0,int i_1=-1,int i_2=-1,int i_3=-1,int i_4=-1,int i_5=-1,int i_6=-1,int i_7=-1,int i_8=-1,int i_9=-1,int i_10=-1,int i_11=-1,int i_12=-1,int i_13=-1,int i_14=-1,int i_15=-1,int i_16=-1,int i_17=-1,int i_18=-1,int i_19=-1 )
		{
			set<i>(i_0);
			set_all_<i+1,n>(Loki::Bool2Type<((i+1)<n)>(),i_1,i_2,i_3,i_4,i_5,i_6,i_7,i_8,i_9,i_10,i_11,i_12,i_13,i_14,i_15,i_16,i_17,i_18,i_19);
		}
		template<int i,int n>
		void set_all_(Loki::Bool2Type<false> ,int i_0,int i_1=-1,int i_2=-1,int i_3=-1,int i_4=-1,int i_5=-1,int i_6=-1,int i_7=-1,int i_8=-1,int i_9=-1,int i_10=-1,int i_11=-1,int i_12=-1,int i_13=-1,int i_14=-1,int i_15=-1,int i_16=-1,int i_17=-1,int i_18=-1,int i_19=-1 )
		{
		}
	};

	///
	///
	///
	template<int i,class IList>
	void print(std::ostream& os,const SizeList_base<IList>& sl,Loki::Int2Type<i>)
	{
		print(os,sl,Loki::Int2Type<i-1>());
		os << (sl.isEnum<i>()?" enum:":" int:") << sl.x<i>();
	}
	///
	///
	///
	template<class IList>
	void print(std::ostream& os,const SizeList_base<IList>& sl,Loki::Int2Type<-1>)
	{
	}
	///
	///
	///
	template<class IList>
	void print(std::ostream& os,const SizeList_base<IList>& sl)
	{
		os << "{";
		print(os,sl,Loki::Int2Type<SizeList_base<IList>::size-1>());
		os << " }" << std::endl;
	}

	///
	///
	///
	template<int i_0,int i_1=-1,int i_2=-1,int i_3=-1,int i_4=-1,int i_5=-1,int i_6=-1,int i_7=-1,int i_8=-1,int i_9=-1,int i_10=-1,int i_11=-1,int i_12=-1,int i_13=-1,int i_14=-1,int i_15=-1,int i_16=-1,int i_17=-1,int i_18=-1,int i_19=-1>
	class SizeList
		: public SizeList_base<
				typename IL::Make<i_0,i_1,i_2,i_3,i_4,i_5,i_6,i_7,i_8,i_9,i_10,i_11,i_12,i_13,i_14,i_15,i_16,i_17,i_18,i_19>::Result
				>
	{
	public:
		SizeList(int i_0,int i_1=-1,int i_2=-1,int i_3=-1,int i_4=-1,int i_5=-1,int i_6=-1,int i_7=-1,int i_8=-1,int i_9=-1,int i_10=-1,int i_11=-1,int i_12=-1,int i_13=-1,int i_14=-1,int i_15=-1,int i_16=-1,int i_17=-1,int i_18=-1,int i_19=-1)
		{
			set_all(i_0,i_1,i_2,i_3,i_4,i_5,i_6,i_7,i_8,i_9,i_10,i_11,i_12,i_13,i_14,i_15,i_16,i_17,i_18,i_19);
		}
	};

	///
	///
	///
	///
	///
	template<typename T,class IList>
	class Layout
		: private SizeList_base<IList>
	{
	public:
		typedef T value_type;
		typedef SizeList_base<IList> SList;
		enum { Ndim   = IL::Length<IList>::value-2};
		enum { isGray = IL::Elem<Ndim,SList::IList>::value};
	private:
		typedef SList Base;
	public:
		//SList lay;
		template<typename T,class SZList,int NBands,int Interleave,int Granulation,int align_to> friend class LayoutListDefault;
		//friend class LayoutListDirect;
	public:
		Layout()
			: Base()
		{
			//set_all(i_0,i_1,i_2,i_3,i_4,i_5,i_6,i_7,i_8,i_9,i_10,i_11,i_12,i_13,i_14,i_15,i_16,i_17,i_18,i_19);
		}
		template<int i>
		int stride() const
		{
			return x<i>();
		}
		int stride_band() const
		{
			return x<Ndim+1>();
		}
		int Bands() const
		{
			return x<Ndim>();
		}
		template<typename T,class IList>
		friend void print(std::ostream& os,const Layout<T,IList>& lay);
	};
	///
	///
	///
	template<typename T,class IList>
	void print(std::ostream& os,const Layout<T,IList>& lay)
	{
		os << "{";
		print(os,lay,Loki::Int2Type<Layout<T,IList>::SList::size-1>());
		os << " }" << std::endl;
	}
	template<typename T,class IList,int NBands,int Interleave,int Granulation,int align_to>
	class BuildDefaultLayout
	{
		enum {sz=IL::Length<IList>::value};
		///// !  i==Granulation, to stride=1;  ,  I==Granulation ???
		/// ,  i>=Granulation -   Align -   !
		template<int i,int I>
		struct S
		{
			enum { bands_stride= S<i-1,I>::bands_stride };
			enum { stride= (i==Granulation)? 1 : Align< T, S<i-1,I>::stride * IL::Elem<i-1,IList>::value ,align_to>::value  };
			typedef typename IL::PushBack<stride,typename S<i-1,I>::Result>::Result Result;
		};
		template<>
		struct S<0,0>
		{
			enum { bands_stride = 1 };
			enum { stride = NBands };
			typedef IndexList<stride,Loki::NullType> Result;
		};
		template<int I>
		struct S<0,I>
		{
			enum { bands_stride = 0 };
			enum { stride = 1 };
			typedef IndexList<stride,Loki::NullType> Result;
		};
		template<int i>
		struct S<i,i>
		{
			enum { bands_stride= (i==Granulation)? 1 : Align< T, S<i-1,i>::stride * IL::Elem<i-1,IList>::value ,align_to>::value  };;
			enum { stride= bands_stride * NBands };
			typedef typename IL::PushBack<stride,typename S<i-1,i>::Result>::Result Result;
		};
		////template<int I>
		////struct S<sz,I>
		////{
		////	enum { bands_stride= 137};//S<sz-1,I>::bands_stride };
		////	typedef typename IL::PushBack<bands_stride,typename S<sz-1,I>::Result>::Result Result;
		////};
		////template<>
		////struct S<sz,sz>
		////{
		////	enum { bands_stride= Align< T, S<sz-1,sz>::stride * IL::Elem<sz-1,IList>::value ,align_to>::value  };;
		////	typedef typename IL::PushBack<bands_stride,typename S<sz-1,sz>::Result>::Result Result;
		////};
		typedef typename S<sz-1,Interleave> SS;
		enum { bbstride = S<sz,Interleave>::bands_stride };
		typedef typename IL::PushBack<bbstride,typename SS::Result>::Result Temp;
	public:
		typedef typename IL::PushBack<NBands,Temp>::Result Result;
		////typedef typename IL::PushBack<NBands,typename S<sz,Interleave>::Result>::Result Result;
/*
		///    stride  
		template<int i>
		struct BuildDefaultLayout_
		{
			typedef BuildDefaultLayout_<i-1> Base;
			enum {ss = Align<T,Base::ss * IL::Elem<i-1,IList>::value *((i==Interleave)?NBands:1),align_to>::value };
			typedef typename IL::PushBack<ss,typename Base::Result>::Result Result;
		};
		///   - stride   
		template<>
		struct BuildDefaultLayout_<0>
		{
			enum {ss=((0==Interleave)?NBands:1)};
			typedef IndexList<ss,Loki::NullType> Result;
		};
		///    -    .  ,  
		///  ,   (enum)       ,  
		///               SizeList_base.
		template<>
		struct BuildDefaultLayout_<sz>
		{
			typedef BuildDefaultLayout_<sz-1> Base;
			enum {ss = NBands };
			typedef typename IL::PushBack<ss,typename Base::Result>::Result Result;
		};
		///   Temp  stride     x<0>,x<1>,x<2>,...,x<Ndim-1> . 
		/// x<Ndim>    (Bands). 
		typedef typename BuildDefaultLayout_<sz>::Result Temp;
		///    band_stride    x<Ndim+1> . 
		///  Lst -     Temp,  I- Interleave
		template<class Lst,int I>
		struct Add_band_stride
		{
			/// 0< I <= NDim.  band_stride   stride<  I-1> 
			///      I-1.
			///       BuildDefaultLayout_,      NBands.
			enum { value = Align<T, IL::Elem<I-1,Lst>::value * IL::Elem<I-1,IList>::value ,align_to>::value };
		};
		template<class Lst>
		struct Add_band_stride<Lst,0>
		{
			// Interleave=0 -  BIP, stride    1.
			enum { value = 1 };
		};
		enum { band_stride = Add_band_stride<Temp,Interleave>::value };
	public:
		///   -  stride  .  ,  
		///  ,   (enum)       ,  
		///               SizeList_base.
		///    NBands=1 :   stride    ,   
		///   band_stride=1 -   enum, ..     .  
		typedef typename IL::PushBack<band_stride,Temp>::Result  Result;
*/
	};

	template<typename T,class SZList,int NBands,int Interleave=SZList::size ,int Granulation=SZList::size ,int align_to =1>
	class LayoutListDefault
	{
	public:
		typedef typename BuildDefaultLayout<T,typename SZList::IList,NBands,Interleave,Granulation,align_to>::Result IList;
		//SizeList_base<IList> strides;
		typedef Layout<T,IList> LayoutType;
		LayoutType strides;
		enum { strides_size=IL::Length<IList>::value};
		enum { ndim=SZList::size };
		operator LayoutType() const {return strides;} 
		//typedef IList;
		LayoutListDefault(SZList sl,int nbands) 
		{
			if(NBands==0) 
				nbands=NBands;
			build(sl,nbands,Loki::Int2Type<0>());
			std::cout << "LayoutList: sl:" <<std::endl;
			print(std::cout,sl);
			std::cout << "LayoutList: strides:" <<std::endl;
			print(std::cout,strides);
			std::cout << "LayoutList: builded:" <<std::endl;
		}
	private:
		template<int i>
		void build(const SZList& sl,int nbands,Loki::Int2Type<i> )
		{
			if(!strides.isEnum<i>())
			{
				int value=  align<T>(strides.x<i-1>() * sl.x<i-1>() * ((i==Interleave)?nbands:1),align_to) ;
				//int value=137;
				strides.set<i>(value);
			}
			//std::cout << "build() " <<i << std::endl;
			build(sl,nbands,Loki::Int2Type<i+1>() );
		}
		void build(const SZList& sl,int nbands,Loki::Int2Type<0> )
		{// Do nothing, end of static recursion
			if(!strides.isEnum<0>())
			{
				strides.set<0>((0==Interleave)?nbands:1);
			}
			//std::cout << "build() " << 0 << std::endl;
			build(sl,nbands,Loki::Int2Type<1>() );
		}
		void build(const SZList& sl,int nbands,Loki::Int2Type<strides_size-1> )
		{// Do nothing, end of static recursion
			//std::cout << "build() " << strides_size << "  end" << std::endl;
			if(!strides.isEnum<strides_size-1>())
			{
				strides.set<strides_size-1>(nbands);
			}
		}
	};
	

	template<int NBands,int s_0,int s_1=-1,int s_2=-1,int s_3=-1,int s_4=-1,int s_5=-1,int s_6=-1,int s_7=-1,int s_8=-1,int s_9=-1,int s_10=-1,int s_11=-1,int s_12=-1,int s_13=-1,int s_14=-1,int s_15=-1,int s_16=-1,int s_17=-1,int s_18=-1,int s_19=-1>
	struct LayoutListDirect
	{
		typedef typename IL::PushBack<NBands,typename IL::Make<s_0,s_1,s_2,s_3,s_4,s_5,s_6,s_7,s_8,s_9,s_10,s_11,s_12,s_13,s_14,s_15,s_16,s_17,s_18,s_19>::Result>::Result IList;
		SizeList_base<IList> strides;
		enum { strides_size=IL::Length<IList>::value};
		enum { ndim=SZList::size };

		LayoutListDirect(int nbands,int s_0,int s_1=-1,int s_2=-1,int s_3=-1,int s_4=-1,int s_5=-1,int s_6=-1,int s_7=-1,int s_8=-1,int s_9=-1,int s_10=-1,int s_11=-1,int s_12=-1,int s_13=-1,int s_14=-1,int s_15=-1,int s_16=-1,int s_17=-1,int s_18=-1,int s_19=-1)
		{
			strides.set_all(s_0,s_1,s_2,s_3,s_4,s_5,s_6,s_7,s_8,s_9,s_10,s_11,s_12,s_13,s_14,s_15,s_16,s_17,s_18,s_19);
			if(NBands==0) 
				nbands=NBands;
		//	build(sl,nbands,Loki::Int2Type<0>());
			std::cout << "LayoutList: sl:" <<std::endl;
			print(std::cout,sl);
			std::cout << "LayoutList: strides:" <<std::endl;
			print(std::cout,strides);
			std::cout << "LayoutList: builded:" <<std::endl;
		}
	private:
		/*
		template<int i>
		void build(const SZList& sl,int nbands,Loki::Int2Type<i> )
		{
			if(!strides.isEnum<i>())
			{
				int value=  align<T>(strides.x<i-1>() * sl.x<i-1>() * ((i==Interleave)?nbands:1),align_to) ;
				//int value=137;
				strides.set<i>(value);
			}
			//std::cout << "build() " <<i << std::endl;
			build(sl,nbands,Loki::Int2Type<i+1>() );
		}
		void build(const SZList& sl,int nbands,Loki::Int2Type<0> )
		{// Do nothing, end of static recursion
			if(!strides.isEnum<0>())
			{
				strides.set<0>((0==Interleave)?nbands:1);
			}
			//std::cout << "build() " << 0 << std::endl;
			build(sl,nbands,Loki::Int2Type<1>() );
		}
		void build(const SZList& sl,int nbands,Loki::Int2Type<strides_size-1> )
		{// Do nothing, end of static recursion
			//std::cout << "build() " << strides_size << "  end" << std::endl;
			if(!strides.isEnum<strides_size-1>())
			{
				strides.set<strides_size-1>(nbands);
			}
		}
		*/
	};


}//namespace Meta
}//namespace Vtl
///////////////////////////////////////////////////////////////////////////////////////////
#endif //_VTL_META_SIZELIST_H
